Index: geniuswebcore/test/geniusweb/issuevalue/DiscreteValueSetTest.py
===================================================================
--- geniuswebcore/test/geniusweb/issuevalue/DiscreteValueSetTest.py	(revision 66)
+++ geniuswebcore/test/geniusweb/issuevalue/DiscreteValueSetTest.py	(revision 67)
@@ -1,2 +1,4 @@
+import json
+from typing import List
 import unittest
 
@@ -9,29 +11,76 @@
 
 class DiscreteValueSetTest(unittest.TestCase):
-    pyson=ObjectMapper()
-    val = DiscreteValueSet([DiscreteValue("a"), DiscreteValue("b")])
-    val1 = DiscreteValueSet([DiscreteValue("a"), DiscreteValue("b")])
-    val2 = DiscreteValueSet([DiscreteValue("a"), DiscreteValue("c")])
-    valjson = {"values":["a","b"]}
 
-    def testSerialize(self):
-        print(str(self.pyson.toJson(self.val)))
-        self.assertEqual(self.valjson, self.pyson.toJson(self.val))
-        
+    A = DiscreteValue("a");
+    A1 = DiscreteValue("a");
+    B = DiscreteValue("b");
+    values:List[DiscreteValue]  = [A, B]
+    valuesReverse = [B, A]
+
+    set1 = DiscreteValueSet(values)
+    setReverse = DiscreteValueSet(valuesReverse)
+    asString = "{\"values\":[\"a\",\"b\"]}"
+    # String asString = "{\"DiscreteValueSet
+    # \":[\"a\",\"b\"]}";
+    asString1 = "[\"a\",\"b\"]"
+
+    # SPECIAL. note that the "numbers" have no leading "=" and therefore are
+    # parsed as discrete values.
+    discretenumbers = "{\"values\":[\"0\",\"1\"]}"
+    jackson = ObjectMapper()
+
+    def  testSerialize(self) :
+        jsonobj = self.jackson.toJson(self.set1)
+        print(jsonobj)
+        self.assertEqual(json.loads(self.asString), jsonobj)
+
     def testDeserialize(self):
-        self.assertEqual(self.val, self.pyson.parse(self.valjson, ValueSet))
-        
-        
-    def testIterator(self):
-        self.assertTrue(DiscreteValue("a") in self.val)
-        
-            
-    def testRepr(self):
-        self.assertEqual("DiscreteValueSet[a, b]", repr(self.val))
-        
-    def testEqual(self):
-        self.assertEqual(self.val, self.val1)
-        self.assertNotEqual(self.val, self.val2)
-        self.assertEqual(hash(self.val), hash(self.val1))
-        self.assertNotEqual(hash(self.val), hash(self.val2))
-        
+        p = self.jackson.parse(json.loads(self.asString), DiscreteValueSet)
+        print(p)
+        self.assertEqual(self.set1, p)
+
+    def testDeserializeNumberValues(self):
+        p = self.jackson.parse(json.loads(self.discretenumbers), DiscreteValueSet)
+        print(p)
+        self.assertEqual("0", p.get(0).getValue()) # not the number but string
+        self.assertEquals("1", p.get(1).getValue())
+
+    def testEquality(self):
+        self.assertEqual(self.set1, self.setReverse)
+
+    def testHashCodeInsensitiveToOrder(self):
+        self.assertEqual(hash(self.set1), hash(self.setReverse))
+
+    def testSize(self):
+        self.assertEqual(2, self.set1.size())
+
+    def testGet(self): 
+        self.assertEqual(self.A, self.set1.get(0))
+        self.assertEqual(self.B, self.set1.get(1))
+        self.assertEqual(self.A, self.set1.get(0))
+        self.assertEqual(self.B, self.set1.get(1))
+
+    def testgetValues(self):
+        self.assertEqual(self.values, self.set1.getValues())
+
+    def testConstructor2(self):
+        self.assertEqual(self.set1, DiscreteValueSet([self.A, self.B]))
+
+    def testContains(self):
+        self.assertTrue(self.set1.contains(self.A))
+        self.assertTrue(self.set1.contains(self.A1))
+        self.assertTrue(self.set1.contains(self.B))
+        self.assertFalse(self.set1.contains(DiscreteValue("c")))
+        self.assertFalse(self.set1.contains(None))
+
+    def testiterator1(self) :
+        it = iter(self.set1);
+        self.assertEqual(self.A, next(it));
+        self.assertEqual(self.B, next(it));
+        self.assertRaises(StopIteration, lambda: next(it))
+
+    def testiterator2(self): 
+        it = iter(self.setReverse)
+        self.assertEqual(self.B, next(it))
+        self.assertEqual(self.A, next(it));
+        self.assertRaises(StopIteration,lambda: next(it))
Index: geniuswebcore/test/geniusweb/issuevalue/DiscreteValueTest.py
===================================================================
--- geniuswebcore/test/geniusweb/issuevalue/DiscreteValueTest.py	(revision 66)
+++ geniuswebcore/test/geniusweb/issuevalue/DiscreteValueTest.py	(revision 67)
@@ -1,5 +1,9 @@
+import json
+from pickle import NONE
+from typing import List
 import unittest
 
 from pyson.ObjectMapper import ObjectMapper
+from unitpy.GeneralTests import GeneralTests
 
 from geniusweb.issuevalue.DiscreteValue import DiscreteValue
@@ -7,25 +11,26 @@
 
 
-class DiscreteValueTest(unittest.TestCase):
-    pyson=ObjectMapper()
-    val = DiscreteValue('val')
-    val1 = DiscreteValue('val')
-    val2 = DiscreteValue('val2')
-    valjson = 'val'
+class DiscreteValueTest(unittest.TestCase, GeneralTests[DiscreteValue]):
+    value =  DiscreteValue("a");
+    value1 =  DiscreteValue("a");
+    valueb =  DiscreteValue("b");
+    serialized = "\"a\"";
+    jackson =  ObjectMapper();
 
     def testSerialize(self):
-        print(str(self.pyson.toJson(self.val)))
-        self.assertEqual(self.valjson, self.pyson.toJson(self.val))
+        print(str(self.jackson.toJson(self.value)))
+        self.assertEqual(json.loads(self.serialized), self.jackson.toJson(self.value))
         
-    def testDeserialize(self):
-        self.assertEqual(self.val, self.pyson.parse(self.valjson, Value))
+    def testDeserialize(self) :
+        self.assertEqual(self.value, self.jackson.parse(json.loads(self.serialized), DiscreteValue))
+ 
+    def testDeserializeFromValue(self):
+        self.assertEqual(self.value, self.jackson.parse(json.loads(self.serialized), Value))
         
-    def testRepr(self):
-        self.assertEqual('val', repr(self.val))
-        
-    def testEqual(self):
-        self.assertEqual(self.val, self.val1)
-        self.assertNotEqual(self.val, self.val2)
-        self.assertEqual(hash(self.val), hash(self.val1))
-        self.assertNotEqual(hash(self.val), hash(self.val2))
-        
+
+    def getGeneralTestData(self)->List[List[DiscreteValue]] :
+        return [ [self.value, self.value1], [self.valueb]]
+
+    def getGeneralTestStrings(self)->List[str]:
+        return [self.serialized, "\"b\""]
+    
Index: geniuswebcore/test/geniusweb/issuevalue/DomainTest.py
===================================================================
--- geniuswebcore/test/geniusweb/issuevalue/DomainTest.py	(revision 66)
+++ geniuswebcore/test/geniusweb/issuevalue/DomainTest.py	(revision 67)
@@ -1,2 +1,3 @@
+from decimal import Decimal
 import json
 import unittest
@@ -12,4 +13,5 @@
 
 class DomainTest (unittest.TestCase) :
+    maxDiff=None
 
     pyson=ObjectMapper()
@@ -55,11 +57,41 @@
         self.assertEqual(self.jobs, self.pyson.parse(self.jobsjson, Domain))
     
+    def testInit(self):
+        self.assertRaises(ValueError, lambda: Domain("name",None))
+        self.assertRaises(ValueError, lambda: Domain(None,{"issue"}))
+        self.assertRaises(ValueError, lambda: Domain("_invalid_name",{"issue"}))
+        self.assertRaises(ValueError, lambda: Domain("name",{}))
+        
     def testIsFitting(self):
         self.assertEqual(None,self.jobs.isFitting(Bid({"lease car":DiscreteValue("no")})))
-        self.assertTrue("illegal value maybe" in self.jobs.isFitting(Bid({"lease car":DiscreteValue("maybe")})))
+        self.assertTrue("refers to non-domain issue" in self.jobs.isFitting(Bid({"no such issue":DiscreteValue("no")})))
+        self.assertNotEqual(None,self.jobs.isFitting(Bid({"lease car":NumberValue(Decimal(1))})))
+        self.assertTrue('illegal value' in self.jobs.isFitting(Bid({"lease car":DiscreteValue("maybe")})))
+     
+    def testIsComplete(self):
+        self.assertEqual(None,self.jobs.isComplete(Bid({"lease car":DiscreteValue("no"),
+                                                        "permanent contract":DiscreteValue("yes"),
+                                                        "career development opportunities":DiscreteValue("high"),
+                                                        "fte":DiscreteValue("1.0"),
+                                                        "salary":DiscreteValue("3000"),
+                                                        "work from home":DiscreteValue("1")
+                                                        })))
+        self.assertTrue("do not match issues in domain" in self.jobs.isComplete(Bid({"lease car":DiscreteValue("no"),
+                                                        "permanent contract":DiscreteValue("yes"),
+                                                        "work from home":DiscreteValue("1")
+                                                        })))
         
+    def testGetValues(self):
+        self.assertEqual(self.jobs.getValues("lease car"),self.yesno)
+        
+    def testgetIssues(self):
+        self.assertEqual(self.jobs.getIssues(),{'permanent contract', 'fte', 'lease car', 'career development opportunities', 'salary', 'work from home'})
+               
+    def testgetName(self):
+        self.assertEqual(self.jobs.getName(),"jobs")
+
     def testRepr(self):
-        self.assertEqual("Domain[jobs,{'lease car': DiscreteValueSet[yes, no], 'permanent contract': DiscreteValueSet[yes, no], 'career development opportunities': DiscreteValueSet[low, medium, high], 'fte': DiscreteValueSet[0.6, 0.8, 1.0], 'salary': DiscreteValueSet[2000, 2500, 3000, 3500, 4000], 'work from home': DiscreteValueSet[0, 1, 2]}]", \
-                            repr(self.jobs))
+        self.assertEqual("Domain[jobs,{'lease car': DiscreteValueSet[\"yes\", \"no\"], 'permanent contract': DiscreteValueSet[\"yes\", \"no\"], 'career development opportunities': DiscreteValueSet[\"low\", \"medium\", \"high\"], 'fte': DiscreteValueSet[\"0.6\", \"0.8\", \"1.0\"], 'salary': DiscreteValueSet[\"2000\", \"2500\", \"3000\", \"3500\", \"4000\"], 'work from home': DiscreteValueSet[\"0\", \"1\", \"2\"]}]"\
+                         ,repr(self.jobs))
         
     def testEqual(self):
Index: geniuswebcore/test/geniusweb/issuevalue/NumberValueSetTest.py
===================================================================
--- geniuswebcore/test/geniusweb/issuevalue/NumberValueSetTest.py	(revision 66)
+++ geniuswebcore/test/geniusweb/issuevalue/NumberValueSetTest.py	(revision 67)
@@ -17,4 +17,7 @@
     valjson = {"range":{"low":12.2,"high":12.6,"step":0.3}}
 
+    def testInit(self):
+        self.assertRaises(ValueError, lambda: NumberValueSet(range(1,5)))
+        
     def testSerialize(self):
         print(str(self.pyson.toJson(self.val)))
Index: geniuswebcore/test/geniusweb/issuevalue/NumberValueTest.py
===================================================================
--- geniuswebcore/test/geniusweb/issuevalue/NumberValueTest.py	(revision 66)
+++ geniuswebcore/test/geniusweb/issuevalue/NumberValueTest.py	(revision 67)
@@ -1,6 +1,9 @@
 from _decimal import Decimal
+import json
+from typing import List, Any
 import unittest
 
 from pyson.ObjectMapper import ObjectMapper
+from unitpy.GeneralTests import GeneralTests
 
 from geniusweb.issuevalue.NumberValue import NumberValue
@@ -8,28 +11,71 @@
 
 
-class NumberValueTest(unittest.TestCase):
-    pyson=ObjectMapper()
-    val = NumberValue(Decimal('0.1237'))
-    val2 = NumberValue(Decimal('2'))
-    valjson = 0.1237
+class NumberValueTest(unittest.TestCase, GeneralTests[NumberValue]):
+    value =  NumberValue(Decimal("12.31"))
+    value1 =  NumberValue(Decimal("12.31"))
+    value1c = NumberValue(Decimal("1.231E+1"))
+    valueb =  NumberValue(Decimal("12.310000000000000001"))
+    serialized = "12.31"
 
-    def testSerialize(self):
-        print(str(self.pyson.toJson(self.val)))
-        self.assertEqual(self.valjson, self.pyson.toJson(self.val))
+    bigserialized = "8748703924870439218876954320948372058"
+    bigvalue = NumberValue(Decimal(bigserialized))
+    jackson = ObjectMapper()
+
+    def getGeneralTestData(self)->List[List[NumberValue]]:
+        return [ [self.value, self.value1, self.value1c], [self.valueb]]
+    
+    def  getGeneralTestStrings(self)->List[str]:
+        return ["12.31", "12.310000000000000001"]
+
+    def testSerialize(self) :
+        self.assertEquals(json.loads(self.serialized), self.jackson.toJson(self.value))
+
+    def testDeserialize(self):
+        self.assertEqual(self.value, self.jackson.parse(json.loads(self.serialized), NumberValue))
+
+    def  testDeserializeFromValue(self):
+        self.assertEqual(self.value, self.jackson.parse(json.loads(self.serialized), Value))
+
+    def testBigSerialize(self):
+        self.assertEqual(json.loads(self.bigserialized), self.jackson.toJson(self.bigvalue))
+
+    def testBigDeserialize(self):
+        self.assertEquals(self.bigvalue,
+                self.jackson.parse(json.loads(self.bigserialized), NumberValue))
+
+    def testSerializeShorts(self):
+        print(self.jackson.toJson([ 1, 2, 3, 4, 5 ]))
+
+    def testDeserializeShorts(self) :
+        list = self.jackson.parse(json.loads("[1,2,3,4,5]"),List[Any])
+        print(list)
+        print(list[0].__class__)
+
+    def testDeserializeMix(self):
+        list = self.jackson.parse(json.loads('["short",1,2,3,4,5]'), List[Any])
+        print(list)
+        print(list[0].__class__)
+
+    def testDeserializePlainNumber(self):
+        '''
+        Showing that we CAN deserialize big numbers without double quotes
+        correctly, if we tell jackson upfront that it's a BigDecimal.
+        '''
+        valstr = "483958743698732691487326987569213874694328974329874328947320984372498327493827432987231874681273648127";
+        val = self.jackson.parse(valstr, Decimal)
+        self.assertEqual(valstr, str(val))
+
+
+    def testNumberBlab(self):
+        # jackson.enable(DeserializationFeature.USE_BIG_DECIMAL_FOR_FLOATS);
+        self.assertEqual(self.value, self.jackson.parse(json.loads("12.31"), Value))
         
-    def testDeserialize(self):
-        self.assertEqual(self.val, self.pyson.parse(self.valjson, Value))
-        
-    def testSerialize2(self):
-        print(str(self.pyson.toJson(NumberValue(Decimal("900")))))
-        
-    def testNonDecimal(self):
-        self.assertRaises(ValueError, lambda:NumberValue(1200))
+    def testNonNumber(self):
+        self.assertRaises(ValueError, lambda: NumberValue("abc"))
 
-    def testHash(self):
-        self.assertEqual(self.val,self.val)
-        self.assertNotEqual(self.val,self.val2)
-        self.assertNotEqual(hash(self.val), hash(self.val2))
-        
-    def testRepr(self):
-        self.assertEqual('2', repr(self.val2))
+    def testDeserializeScientificNotation(self):
+        valstr = "9E+2";
+        val = self.jackson.parse(json.loads(valstr), Value)
+        # self.assertEqual(valstr, str(val)) FIXME? 
+        self.assertEqual(val, NumberValue(Decimal("900")))
+    
Index: geniuswebcore/test/geniusweb/issuevalue/ValueDeserializerTest.py
===================================================================
--- geniuswebcore/test/geniusweb/issuevalue/ValueDeserializerTest.py	(revision 67)
+++ geniuswebcore/test/geniusweb/issuevalue/ValueDeserializerTest.py	(revision 67)
@@ -0,0 +1,16 @@
+import unittest
+from decimal import Decimal
+
+from geniusweb.issuevalue.ValueDeserializer import ValueDeserializer
+from geniusweb.issuevalue.DiscreteValue import DiscreteValue
+from geniusweb.issuevalue.NumberValue import NumberValue
+
+class ValueDeserializerTest(unittest.TestCase):
+       
+    val = ValueDeserializer()
+    
+    def testValueDeserializer(self):
+        #self.assertEqual(DiscreteValue(123),self.val.deserialize(123,1))
+        self.assertEqual(DiscreteValue("123"),self.val.deserialize("123",1))
+        self.assertEqual(NumberValue(Decimal(123)), self.val.deserialize(123,1))
+        self.assertRaises(ValueError,lambda: self.val.deserialize([1,2,3],1))
Index: geniuswebcore/test/geniusweb/party/DefaultPartyTest.py
===================================================================
--- geniuswebcore/test/geniusweb/party/DefaultPartyTest.py	(revision 66)
+++ geniuswebcore/test/geniusweb/party/DefaultPartyTest.py	(revision 67)
@@ -2,4 +2,5 @@
 from geniusweb.party.DefaultParty import DefaultParty       
 from geniusweb.party.Capabilities import Capabilities
+from geniusweb.inform.Inform import Inform
       
 class MyParty(DefaultParty):
@@ -10,5 +11,5 @@
         return "blabla"
     
-    def notifyChange(self, data:int):
+    def notifyChange(self, data:Inform):
         # you'd think the type checker would complain here. data is NOT int
         return 
Index: geniuswebcore/test/geniusweb/partystdio/EmptyParty.py
===================================================================
--- geniuswebcore/test/geniusweb/partystdio/EmptyParty.py	(revision 66)
+++ geniuswebcore/test/geniusweb/partystdio/EmptyParty.py	(revision 67)
@@ -2,5 +2,5 @@
 import logging
 import sys
-from typing import cast
+from typing import cast, Optional, List
 
 from tudelft_utilities_logging.Reporter import Reporter 
@@ -21,6 +21,6 @@
         super().__init__(reporter)
         self.getReporter().log(logging.INFO,"party is initialized")
-        self._lastReceivedBid:Bid = None
-        self.received=[]
+        self._lastReceivedBid:Optional[Bid] = None
+        self.received:List[Inform]=[]
 
     # Override
Index: geniuswebcore/test/geniusweb/profile/utilityspace/DiscreteValSetUtilsTest.py
===================================================================
--- geniuswebcore/test/geniusweb/profile/utilityspace/DiscreteValSetUtilsTest.py	(revision 66)
+++ geniuswebcore/test/geniusweb/profile/utilityspace/DiscreteValSetUtilsTest.py	(revision 67)
@@ -37,5 +37,5 @@
 
     def testRepr(self):
-        self.assertEqual("DiscreteValueSetUtilities{high: Decimal('1'), low: Decimal('0'), medium: Decimal('0.5')}", repr(self.carreerutils))
+        self.assertEqual('DiscreteValueSetUtilities{"high"=1, "low"=0, "medium"=0.5}', repr(self.carreerutils))
         
     def testEqual(self):
Index: geniuswebcore/test/geniusweb/profileconnection/ProfileConnectionFactoryTest.py
===================================================================
--- geniuswebcore/test/geniusweb/profileconnection/ProfileConnectionFactoryTest.py	(revision 66)
+++ geniuswebcore/test/geniusweb/profileconnection/ProfileConnectionFactoryTest.py	(revision 67)
@@ -1,6 +1,7 @@
+from builtins import BaseException
 import unittest
 
 from tudelft_utilities_logging.Reporter import Reporter
-from uri import URI
+from uri.uri import URI
 
 from geniusweb.profileconnection.ProfileConnectionFactory import ProfileConnectionFactory
@@ -8,5 +9,5 @@
 
 class DummyReporter(Reporter):
-    def log(self, level:int, msg:str, thrown:Exception=None):
+    def log(self, level:int, msg:str, thrown:BaseException=None):
         print(msg)
 
Index: geniuswebcore/test/geniusweb/profileconnection/WebSocketProfileConnectorTest.py
===================================================================
--- geniuswebcore/test/geniusweb/profileconnection/WebSocketProfileConnectorTest.py	(revision 66)
+++ geniuswebcore/test/geniusweb/profileconnection/WebSocketProfileConnectorTest.py	(revision 67)
@@ -3,9 +3,10 @@
 import threading
 from time import sleep
+from typing import Optional
 import unittest
 from unittest.mock import Mock
 
 from tudelft_utilities_logging.Reporter import Reporter
-from uri import URI
+from uri.uri import URI
 
 from geniusweb.profileconnection.FileProfileConnector import FileProfileConnector
@@ -17,5 +18,5 @@
 
 class DummyReporter(Reporter):
-    def log(self, level:int, msg:str, thrown:Exception=None):
+    def log(self, level:int, msg:str, thrown:BaseException=None):
         print(msg)
 
Index: geniuswebcore/test/geniusweb/protocol/CurrentNegoStateTest.py
===================================================================
--- geniuswebcore/test/geniusweb/protocol/CurrentNegoStateTest.py	(revision 67)
+++ geniuswebcore/test/geniusweb/protocol/CurrentNegoStateTest.py	(revision 67)
@@ -0,0 +1,42 @@
+from typing import List
+import unittest
+from unittest.mock import Mock
+
+from unitpy.GeneralTests import GeneralTests
+
+from geniusweb.actions.Action import Action
+from geniusweb.actions.PartyId import PartyId
+from geniusweb.progress.ProgressTime import ProgressTime
+from geniusweb.protocol.CurrentNegoState import CurrentNegoState
+from geniusweb.protocol.session.saop.SAOPSettings import SAOPSettings
+from geniusweb.protocol.session.saop.SAOPState import SAOPState
+
+
+class CurrentNegoStateTest (unittest.TestCase,GeneralTests[CurrentNegoState]):
+    party1 = PartyId("party1")
+    party2 = PartyId("party2")
+    actions1:List[Action] = []
+
+    connections = [party1]
+    connections2 = [party1, party2]
+
+    progresstime = Mock(ProgressTime)
+    settings = Mock(SAOPSettings)
+
+    saop1 = SAOPState(actions1, connections2, progresstime,
+            settings)
+    saop2 = SAOPState(actions1, connections, progresstime,
+            settings)
+
+    state1 = CurrentNegoState(saop1, 1234)
+    state1a = CurrentNegoState(saop1,1234)
+    state2 = CurrentNegoState(saop2,1234)
+
+    def getGeneralTestData(self)->List[List[CurrentNegoState]] :
+        return [[self.state1, self.state1a],[self.state2]]
+
+    def getGeneralTestStrings(self)->List[str] :
+        return [
+                "CurrentNegoState.*1234.*SAOPState.*party1.*party2.*ProgressTime.*SAOPSettings.*",
+                "CurrentNegoState.*1234.*SAOPState.*party1.*ProgressTime.*SAOPSettings.*"]
+
Index: geniuswebcore/test/geniusweb/protocol/ProtocolExceptionTest.py
===================================================================
--- geniuswebcore/test/geniusweb/protocol/ProtocolExceptionTest.py	(revision 67)
+++ geniuswebcore/test/geniusweb/protocol/ProtocolExceptionTest.py	(revision 67)
@@ -0,0 +1,22 @@
+import traceback
+import unittest
+
+from geniusweb.actions.PartyId import PartyId
+from geniusweb.protocol.ProtocolException import ProtocolException
+
+
+class ProtocolExceptionTest(unittest.TestCase):
+    def testConstructor(self):
+        party = PartyId("test")
+        try:
+            x=1/0
+        except Exception as e:
+            err = ProtocolException("div by zero", party,  e)
+            
+        print(err) # BUG ? FEATURE? this does NOT show the cause nor the stacktrace... 
+        self.assertTrue(err)
+        self.assertTrue(err.__cause__)
+
+    def testNullParty(self):
+        ProtocolException("test",None, None)
+        
Index: geniuswebcore/test/geniusweb/protocol/session/ConnectionWithPartiesTest.py
===================================================================
--- geniuswebcore/test/geniusweb/protocol/session/ConnectionWithPartiesTest.py	(revision 67)
+++ geniuswebcore/test/geniusweb/protocol/session/ConnectionWithPartiesTest.py	(revision 67)
@@ -0,0 +1,80 @@
+from typing import List
+import unittest
+from unittest.mock import Mock
+
+from unitpy.GeneralTests import GeneralTests
+
+from geniusweb.actions.PartyId import PartyId
+from geniusweb.protocol.partyconnection.ProtocolToPartyConn import ProtocolToPartyConn
+from geniusweb.protocol.partyconnection.ProtocolToPartyConnections import ProtocolToPartyConnections
+
+
+class ConnectionWithPartiesTest (unittest.TestCase, GeneralTests[ProtocolToPartyConnections]):
+	party1 = PartyId("party1")
+	party2 = PartyId("party2")
+	party3 = PartyId("party3")
+
+	con1 = Mock(ProtocolToPartyConn)
+	con2 = Mock(ProtocolToPartyConn)
+	con3 = Mock(ProtocolToPartyConn)
+
+	conns1 = ProtocolToPartyConnections([con1, con2])
+	conns1a = ProtocolToPartyConnections([con1, con2])
+	conns2 = ProtocolToPartyConnections([con1, con3])
+	conns3 = ProtocolToPartyConnections([con2, con1])
+	conns4 = ProtocolToPartyConnections([con2, con1, con3])
+	conns5 = ProtocolToPartyConnections([con2, con1, con3, con1])
+
+	con1.__repr__=Mock(return_value="con1") #type:ignore
+	con2.__repr__=Mock(return_value="con2") #type:ignore
+	con3.__repr__=Mock(return_value="con3")  #type:ignore
+	
+	con1.getParty=Mock(return_value=party1)
+	con2.getParty=Mock(return_value=party2)
+	con3.getParty=Mock(return_value=party3)
+
+
+	def getGeneralTestData(self)->List[List[ProtocolToPartyConnections]] :
+		return [[self.conns1, self.conns1a],[self.conns2], [self.conns3],
+				[self.conns4]]
+
+	def getGeneralTestStrings(self) -> List[str] : 
+		return ["ConnectionWithParties\\[con1, con2\\]",
+				"ConnectionWithParties\\[con1, con3\\]",
+				"ConnectionWithParties\\[con2, con1\\]",
+				"ConnectionWithParties\\[con2, con1, con3\\]"]
+
+	def testGet(self):
+		self.assertEqual(self.con1, self.conns1.getConn(0))
+		self.assertEqual(self.con3, self.conns4.getConn(2))
+
+	def testGetParty(self):
+		self.assertEquals(self.con1, self.conns1.get(self.party1))
+		self.assertEquals(self.con1, self.conns4.get(self.party1))
+		self.assertEquals(self.con2, self.conns1.get(self.party2))
+		self.assertEquals(self.con2, self.conns3.get(self.party2))
+		self.assertEquals(self.con2, self.conns4.get(self.party2))
+	
+	def testGetUnknownParty(self) :
+		self.assertEqual(None, self.conns2.get(self.party2))
+
+	def testSize(self):
+		self.assertEqual(2, self.conns1.size())
+		self.assertEquals(2, self.conns2.size())
+		self.assertEquals(2, self.conns3.size())
+		self.assertEquals(3, self.conns4.size())
+
+	def testWithParty(self) :
+		conns = self.conns3.With(self.con3)
+		self.assertEqual(2, self.conns3.size())
+		self.assertEqual(3, conns.size())
+		self.assertEqual(self.conns4, conns)
+
+	def testWithExistingParty(self):
+		self.conns4.With(self.con1);
+		# no throw, default this is ok, it should be the protocol testing this.
+	
+	def testAllUnique(self):
+		self.assertTrue(self.conns4.allunique());
+		self.assertFalse(self.conns5.allunique());
+
Index: geniuswebcore/test/geniusweb/protocol/session/SessionResultTest.py
===================================================================
--- geniuswebcore/test/geniusweb/protocol/session/SessionResultTest.py	(revision 67)
+++ geniuswebcore/test/geniusweb/protocol/session/SessionResultTest.py	(revision 67)
@@ -0,0 +1,100 @@
+from collections import OrderedDict
+import json
+from typing import List, Dict
+import unittest
+
+from pyson.ObjectMapper import ObjectMapper
+from unitpy.GeneralTests import GeneralTests
+from uri.uri import URI
+
+from geniusweb.actions.PartyId import PartyId
+from geniusweb.inform.Agreements import Agreements
+from geniusweb.issuevalue.Bid import Bid
+from geniusweb.issuevalue.DiscreteValue import DiscreteValue
+from geniusweb.issuevalue.Value import Value
+from geniusweb.protocol.session.SessionResult import SessionResult
+from geniusweb.references.Parameters import Parameters
+from geniusweb.references.PartyRef import PartyRef
+from geniusweb.references.PartyWithParameters import PartyWithParameters
+from geniusweb.references.PartyWithProfile import PartyWithProfile
+from geniusweb.references.ProfileRef import ProfileRef
+
+
+class SessionResultTest(unittest.TestCase,  GeneralTests[SessionResult]):
+	jackson = ObjectMapper()
+	error = ValueError("test");
+
+	ISSUE1 = "issue1";
+	jsonstring = "{\"participants\":{\"party2\":{\"party\":{\"partyref\":\"party2\",\"parameters\":{}},\"profile\":\"profile2\"},\"party1\":{\"party\":{\"partyref\":\"party1\",\"parameters\":{}},\"profile\":\"profile1\"}},\"agreements\":{\"party2\":{\"issuevalues\":{\"issue1\":\"a\"}},\"party1\":{\"issuevalues\":{\"issue1\":\"a\"}}},\"penalties\":{\"party2\":0.0,\"party1\":0.0},\"error\":null}";
+	nopenalties:Dict[PartyId, float] = {}
+	penalties:Dict[PartyId, float]  = {}
+
+	PARTY1 = PartyId("party1")
+	PARTY2 = PartyId("party2")
+	PARTY3 = PartyId("party3")
+
+	penalties[PARTY1]= 0.1
+	penalties[PARTY2]= 0.2
+	nopenalties[PARTY1]= 0.
+	nopenalties[PARTY2]= 0.
+
+	errorstring = "\"error\":{\"java.lang.RuntimeException\":"\
+			+ json.dumps(jackson.toJson(error)) + "}"
+	print(errorstring)
+
+	party1 = PartyWithParameters(PartyRef(URI("party1")), Parameters())
+	party2 = PartyWithParameters(PartyRef(URI("party2")), Parameters())
+
+	partyprofile1 = PartyWithProfile(party1, ProfileRef(URI("profile1")))
+	partyprofile2 = PartyWithProfile(party2, ProfileRef(URI("profile2")))
+
+	issuevalues1:Dict[str, Value] = {}
+	issuevalues1[ISSUE1]=DiscreteValue("a")
+	bid1 = Bid(issuevalues1)
+	agreement1 = Agreements().With(Agreements({PARTY1:bid1, PARTY2:bid1} ))
+
+	# different order but that shouldn't matter
+	issuevalues2:Dict[str, Value]  =OrderedDict()
+	issuevalues2[ISSUE1]= DiscreteValue("b")
+	bid2 = Bid(issuevalues2)
+	agreement2 = Agreements().With(Agreements({ PARTY1:bid2, PARTY3:bid2} ))
+
+	partiesmap:Dict[PartyId, PartyWithProfile] = OrderedDict()
+	partiesmap[PARTY2]= partyprofile2
+	partiesmap[PARTY1]= partyprofile1
+
+	partiesmap2:Dict[PartyId, PartyWithProfile] = OrderedDict()
+	partiesmap2[PARTY1]= partyprofile2
+	partiesmap2[PARTY3]= partyprofile1
+
+	result1 = SessionResult(partiesmap, agreement1, nopenalties, None) 
+	result1a = SessionResult(partiesmap, agreement1, nopenalties, None)
+	result2 = SessionResult(partiesmap, agreement2, nopenalties, None)
+	result3 = SessionResult(partiesmap2, agreement1, nopenalties, None)
+	result4 = SessionResult(partiesmap2, agreement1, penalties, None)
+
+	# IGNORE ERROR for now, it fails somewhere deep in maven suddenly.
+	# result4 = new SessionResult(Arrays.asList(partyprofile1,
+	# partyprofile2), bid1, error);
+
+	def getGeneralTestData(self) ->List[List[SessionResult]]: 
+		return [[self.result1, self.result1a],
+				[self.result2], [self.result3],
+				[self.result4]]
+
+	def  getGeneralTestStrings(self) -> List[str]:
+		return [
+				"SessionResult.*party2.*profile2.*,.*party1.*profile1.*Agreements.*Bid.*issue1=\"a\".*0\\.0.*0\\.0.*None.*",
+				"SessionResult.*party2.*profile2.*,.*party1.*profile1.*Agreements.*Bid.*issue1=\"b\".*0\\.0.*0\\.0.*None.*",
+				"SessionResult.*party1.*profile2.*,.*party3.*profile1.*Agreements.*Bid.*issue1=\"a\".*0\\.0.*0\\.0.*None.*",
+				"SessionResult.*party1.*profile2.*,.*party3.*profile1.*Agreements.*Bid.*issue1=\"a\".*party1.*0\\.1.*party2.*0\\.2.*None.*"
+				]
+
+	def serializeTest(self) :
+		print(self.jackson.toJson(self.result1))
+		self.assertEqual(json.loads(self.jsonstring), self.jackson.toJson(self.result1))
+
+	def deserializeTest(self):
+		act = self.jackson.parse(json.loads(self.jsonstring), SessionResult)
+		self.assertEqual(self.result1, act)
+
